import java.util.Vector;

class RVector extends Vector{

	public RVector collect(rblock.Object f) {
		RVector rs = new RVector();
		int i;
		for(i = 0; i < this.size(); i++) rs.addElement(f.call(this.get(i)));
		return rs;
	}
	
	public void map(rblock.Object f) {
		int i;
		for(i = 0; i < this.size(); i++) this.set(i, f.call(this.get(i)));
		return;
	}
	
	public RVector filter(rblock.Boolean f) {
		RVector rs = new RVector();
		int i;
		for(i = 0; i < this.size(); i++) if(f.call(this.get(i))) rs.addElement(this.get(i));
		return rs;
	}
	
	public void foreach(rblock.Void f) {
		int i;
		for(i = 0; i < this.size(); i++) f.call(this.get(i));
		return;
	}

}


class HelloWorld {

	public static void main(String[] args) {
		RVector v = new RVector();
		
		v.addElement("first");
		v.addElement("second");
		v.addElement("third");
		v.addElement("fourth");
		v.addElement("fifth");
		
		final String tail = " element";

		v.filter(boolean {| x |
				return (((String)x).toCharArray()[0] == 'f');
		}).collect( {| w |
				return ((String)w) + tail;
		}).foreach(void {| x |
				System.out.println(x);
		});
		
		final boolean flag = true;
		v.map({|x| return x + " OK!";});
		rblock.Void b = void {|x| if(flag){ System.out.println(x);}};
		v.foreach(b);

	}
}


